package org.bitbucket.bradleysmithllc.etlunit.feature.database.db;

import com.fasterxml.jackson.databind.JsonNode;
import com.google.gson.stream.JsonWriter;

import java.io.IOException;

public class TableColumnImpl implements TableColumn
{
	private String name;
	private int type;
	private boolean nullable;
	private boolean autoIncrement;
	private final Table table;

	public TableColumnImpl(Table table, String name, int type, boolean nullable, boolean autoIncrement)
	{
		this.name = name;
		this.type = type;
		this.nullable = nullable;
		this.autoIncrement = autoIncrement;
		this.table = table;
	}

	public TableColumnImpl(Table table)
	{
		this(table, null, -1, false, false);
	}

	public String getName()
	{
		return name;
	}

	public void setType(int type)
	{
		this.type = type;
	}

	public int getType()
	{
		return type;
	}

	public boolean isNullable()
	{
		return nullable;
	}

	public boolean isAutoIncrement()
	{
		return autoIncrement;
	}

	@Override
	public Table getTable() {
		return table;
	}

	@Override
	public void toJson(JsonWriter writer) throws IOException {
		writer.name("name").value(name);
		writer.name("type").value(type);
		writer.name("nullable").value(nullable);
		writer.name("auto-increment").value(autoIncrement);
	}

	@Override
	public void fromJson(JsonNode node) {
		name = node.get("name").asText();
		type = node.get("type").asInt();
		nullable = node.get("nullable").asBoolean();
		autoIncrement = node.get("auto-increment").asBoolean();
	}
}
